var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var _JSONParseStream_jsonPath, _JSONParseWritable_instances, _JSONParseWritable_readable, _JSONParseWritable_filterStream, _JSONParseWritable_clone;
// deno-lint-ignore-file no-explicit-any no-cond-assign ban-unused-ignore no-unused-vars
import { streamToAsyncIter } from 'whatwg-stream-to-async-iter';
import { JSONParser } from './json-parser.js';
import { normalize, match } from './json-path.js';
async function* _identity(iter) {
    for await (const x of iter)
        yield x;
}
// FIXME: avoid string concatenation/joining
const mkPath = (parser) => {
    const path = [...parser.stack.map((_) => _.key), parser.key]; // TODO: modify parser to provide key efficiently
    path[0] = path[0] || '$';
    return normalize(path.join('.')); // FIXME: avoid string concatenation/joining
};
export class JSONParseStream extends TransformStream {
    constructor(jsonPath = '$.*') {
        let parser;
        const expr = normalize(jsonPath);
        super({
            start: (controller) => {
                parser = new JSONParser();
                parser.onValue = (value) => {
                    const path = mkPath(parser);
                    if (match(expr, path)) {
                        controller.enqueue(value);
                    }
                    else if (expr.startsWith(path)) {
                        // Closing the stream early when the selected path can no longer yield values.
                        controller.terminate();
                    }
                };
            },
            transform: (chunk) => {
                parser.write(chunk);
            },
        });
        _JSONParseStream_jsonPath.set(this, void 0);
        __classPrivateFieldSet(this, _JSONParseStream_jsonPath, expr, "f");
    }
    get path() { return __classPrivateFieldGet(this, _JSONParseStream_jsonPath, "f"); }
}
_JSONParseStream_jsonPath = new WeakMap();
export class JSONParseWritable extends WritableStream {
    // #streams = new Map<string, ReadableStream<unknown>>();
    constructor() {
        let parser;
        let readable;
        super({
            start: (writeCtrl) => {
                parser = new JSONParser();
                readable = new ReadableStream({
                    start: (readCtrl) => {
                        parser.onValue = (value) => {
                            const path = mkPath(parser);
                            readCtrl.enqueue([path, value]);
                        };
                    },
                });
            },
            write: (chunk) => {
                parser.write(chunk);
            },
        });
        _JSONParseWritable_instances.add(this);
        _JSONParseWritable_readable.set(this, void 0);
        __classPrivateFieldSet(this, _JSONParseWritable_readable, readable, "f"); // sus
    }
    /** @deprecated should this be exposed? */
    get readable() {
        return __classPrivateFieldGet(this, _JSONParseWritable_readable, "f");
    }
    async promise(jsonPath) {
        const expr = normalize(jsonPath);
        const stream = __classPrivateFieldGet(this, _JSONParseWritable_instances, "m", _JSONParseWritable_clone).call(this).pipeThrough(__classPrivateFieldGet(this, _JSONParseWritable_instances, "m", _JSONParseWritable_filterStream).call(this, expr));
        // this.#streams.set(expr, stream)
        const { done, value } = await stream.getReader().read();
        return done ? undefined : value;
    }
    stream(jsonPath) {
        const expr = normalize(jsonPath);
        const stream = __classPrivateFieldGet(this, _JSONParseWritable_instances, "m", _JSONParseWritable_clone).call(this).pipeThrough(__classPrivateFieldGet(this, _JSONParseWritable_instances, "m", _JSONParseWritable_filterStream).call(this, expr));
        // this.#streams.set(expr, stream)
        return stream;
    }
    iterable(jsonPath) {
        return streamToAsyncIter(this.stream(jsonPath));
    }
}
_JSONParseWritable_readable = new WeakMap(), _JSONParseWritable_instances = new WeakSet(), _JSONParseWritable_filterStream = function _JSONParseWritable_filterStream(expr) {
    return new TransformStream({
        transform: ([path, value], controller) => {
            if (match(expr, path)) {
                controller.enqueue(value);
            }
            else if (expr.startsWith(path)) {
                // Closing the stream early when the selected path can no longer yield values.
                controller.terminate();
                // this.#streams.delete(expr) // no longer need to track the stream
            }
        }
    });
}, _JSONParseWritable_clone = function _JSONParseWritable_clone() {
    const [a, b] = __classPrivateFieldGet(this, _JSONParseWritable_readable, "f").tee();
    __classPrivateFieldSet(this, _JSONParseWritable_readable, a, "f");
    return b;
};
//# sourceMappingURL=json-parse-stream.js.map