"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.JSONStringifyStream = void 0;
// deno-lint-ignore-file no-explicit-any
const resolvable_promise_1 = require("@worker-tools/resolvable-promise");
const extendable_promise_1 = require("@worker-tools/extendable-promise");
const json_stringify_js_1 = require("./json-stringify.js");
class JSONStringifyStream extends TransformStream {
    constructor() {
        let first;
        let flushed;
        let done;
        super({
            start(controller) {
                first = true;
                flushed = new resolvable_promise_1.ResolvablePromise();
                done = new extendable_promise_1.ExtendablePromise(flushed);
                controller.enqueue('[');
            },
            transform(obj, controller) {
                if (!first)
                    controller.enqueue(',');
                else
                    first = false;
                const p = (async () => {
                    for await (const chunk of (0, json_stringify_js_1.jsonStringifyGenerator)(obj)) {
                        controller.enqueue(chunk);
                    }
                })();
                done.waitUntil(p);
                return p;
            },
            async flush(controller) {
                flushed.resolve();
                await done; // FIXME: is this even necessary?
                controller.enqueue(']');
            }
        });
    }
}
exports.JSONStringifyStream = JSONStringifyStream;
//# sourceMappingURL=json-stringify-stream.js.map